inventory = JSON.parse(File.read('inventory.json'))
vms_config = inventory["managers"] + inventory["workers"]

Vagrant.configure(2) do |config|
    vms_config.each do |vm_config|
        config.vm.define vm_config["hostname"] do |server|
            server.vm.box = "debian/buster64"
            server.vm.hostname = vm_config["hostname"]
            server.vm.network "private_network", ip: vm_config["ip"]

            server.vm.provider :virtualbox do |vb|
                vb.name = vm_config["hostname"]
                vb.memory = vm_config["memory"]
                vb.cpus = vm_config["cpus"]
            end

            # copy ssh key in a file on the virtual machine
            server.vm.provision "file", source: "secrets/id_rsa.pub", destination: "/home/vagrant/.ssh/admin_rsa.pub"
            # copy content of admin public key in authorized keys on the virtual machine
            server.vm.provision "shell", inline: <<-SHELL
                cat /home/vagrant/.ssh/admin_rsa.pub >> /home/vagrant/.ssh/authorized_keys
                rm /home/vagrant/.ssh/admin_rsa.pub
            SHELL
        end
    end
end
